src/base/cs_post.h File Reference

| programmer's documentation

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Macros | Typedefs | Enumerations | Functions
cs_post.h File Reference
`#include "fvm_nodal.h"`
`#include "fvm_writer.h"`
`#include "cs_base.h"`
`#include "cs_time_step.h"`
Include dependency graph for cs_post.h:

Go to the source code of this file.

## Macros
#define | CS_POST_ON_LOCATION
#define | CS_POST_BOUNDARY_NR

## Typedefs
typedef void( | cs_post_elt_select_t )(void *input, cs_lnum_t *n_elts, cs_lnum_t **elt_list)
| Function pointer to elements selection definition. More...
typedef void( | cs_post_time_dep_output_t )(void *input, const cs_time_step_t *ts)
typedef void( | cs_post_time_mesh_dep_output_t )(void *input, int mesh_id, int cat_id, int ent_flag[4], cs_lnum_t n_cells, cs_lnum_t n_i_faces, cs_lnum_t n_b_faces, const cs_lnum_t cell_list[], const cs_lnum_t i_face_list[], const cs_lnum_t b_face_list[], const cs_time_step_t *ts)

## Enumerations
enum | cs_post_type_t { CS_POST_TYPE_cs_int_t, CS_POST_TYPE_cs_real_t, CS_POST_TYPE_int, CS_POST_TYPE_float, CS_POST_TYPE_double }
| Postprocessing input variable type. More...

## Functions
void | cs_post_set_deformable (void)
| Configure the post-processing output so that a mesh displacement field may be output automatically for meshes based on the global volume mesh/. More...
void | cs_post_set_changing_connectivity (void)
| Configure the post-processing output so that mesh connectivity may be automatically updated. More...
void | cs_post_define_writer (int writer_id, const char *case_name, const char *dir_name, const char *fmt_name, const char *fmt_opts, fvm_writer_time_dep_t time_dep, bool output_at_end, int frequency_n, double frequency_t)
| Define a writer; this objects manages a case's name, directory, and format, as well as associated mesh's time dependency, and the default output frequency for associated variables. More...
void | cs_post_define_volume_mesh (int mesh_id, const char *mesh_name, const char *cell_criteria, bool add_groups, bool auto_variables, int n_writers, const int writer_ids[])
| Define a volume post-processing mesh. More...
void | cs_post_define_volume_mesh_by_func (int mesh_id, const char *mesh_name, cs_post_elt_select_t *cell_select_func, void *cell_select_input, bool time_varying, bool add_groups, bool auto_variables, int n_writers, const int writer_ids[])
| Define a volume post-processing mesh using a selection function. More...
void | cs_post_define_surface_mesh (int mesh_id, const char *mesh_name, const char *i_face_criteria, const char *b_face_criteria, bool add_groups, bool auto_variables, int n_writers, const int writer_ids[])
| Define a surface post-processing mesh. More...
void | cs_post_define_surface_mesh_by_func (int mesh_id, const char *mesh_name, cs_post_elt_select_t *i_face_select_func, cs_post_elt_select_t *b_face_select_func, void *i_face_select_input, void *b_face_select_input, bool time_varying, bool add_groups, bool auto_variables, int n_writers, const int writer_ids[])
| Define a surface post-processing mesh using selection functions. More...
void | cs_post_define_particles_mesh (int mesh_id, const char *mesh_name, const char *cell_criteria, double density, bool trajectory, bool auto_variables, int n_writers, const int writer_ids[])
| Define a particles post-processing mesh. More...
void | cs_post_define_particles_mesh_by_func (int mesh_id, const char *mesh_name, cs_post_elt_select_t *p_select_func, void *p_select_input, bool trajectory, bool auto_variables, int n_writers, const int writer_ids[])
| Define a particles post-processing mesh using a selection function. More...
void | cs_post_define_alias_mesh (int mesh_id, int aliased_mesh_id, bool auto_variables, int n_writers, const int writer_ids[])
| Create an alias to a post-processing mesh. More...
void | cs_post_define_existing_mesh (int mesh_id, fvm_nodal_t *exp_mesh, int dim_shift, bool transfer, bool auto_variables, int n_writers, const int writer_ids[])
| Create a post-processing mesh associated with an existing exportable mesh representation. More...
void | cs_post_define_edges_mesh (int mesh_id, int base_mesh_id, int n_writers, const int writer_ids[])
| Create a mesh based upon the extraction of edges from an existing mesh. More...
const int * | cs_post_mesh_get_ent_flag (int mesh_id)
| Get a postprocessing meshes entity presence flag. More...
cs_lnum_t | cs_post_mesh_get_n_cells (int mesh_id)
| Get a postprocessing mesh's number of cells. More...
void | cs_post_mesh_get_cell_ids (int mesh_id, cs_lnum_t *cell_ids)
| Get a postprocessing mesh's list of cells. More...
cs_lnum_t | cs_post_mesh_get_n_i_faces (int mesh_id)
| Get a postprocessing mesh's number of interior faces. More...
void | cs_post_mesh_get_i_face_ids (int mesh_id, cs_lnum_t i_face_ids[])
| Get a postprocessing mesh's list of boundary faces. More...
cs_lnum_t | cs_post_mesh_get_n_b_faces (int mesh_id)
| Get a postprocessing mesh's number of boundary faces. More...
void | cs_post_mesh_get_b_face_ids (int mesh_id, cs_lnum_t b_face_ids[])
| Get a postprocessing mesh's list of boundary faces. More...
void | cs_post_free_mesh (int mesh_id)
| Remove a post-processing mesh. More...
bool | cs_post_writer_exists (int writer_id)
| Check for the existence of a writer of the given id. More...
fvm_writer_t * | cs_post_get_writer (int writer_id)
| Return a pointer to the FVM writer associated to a writer_id. More...
void | cs_post_add_writer_t_step (int writer_id, int nt)
| Add an activation time step for a specific writer or for all writers. More...
void | cs_post_add_writer_t_value (int writer_id, double t)
| Add an activation time value for a specific writer or for all writers. More...
bool | cs_post_mesh_exists (int mesh_id)
| Check for the existence of a post-processing mesh of the given id. More...
void | cs_post_modify_mesh (int mesh_id, cs_lnum_t n_cells, cs_lnum_t n_i_faces, cs_lnum_t n_b_faces, cs_lnum_t cell_list[], cs_lnum_t i_face_list[], cs_lnum_t b_face_list[])
const char * | cs_post_get_default_format (void)
| Return the default writer format name. More...
const char * | cs_post_get_default_format_options (void)
| Return the default writer format options. More...
int | cs_post_get_free_writer_id (void)
| Return the next "reservable" (i.e. non-user) writer id available. More...
int | cs_post_get_free_mesh_id (void)
| Return the next "reservable" (i.e. non-user) mesh id available. More...
void | cs_post_activate_by_time_step (const cs_time_step_t *ts)
| Update "active" or "inactive" flag of writers based on the time step. More...
void | cs_post_activate_writer (int writer_id, bool activate)
| Force the "active" or "inactive" flag for a specific writer or for all writers for the current time step. More...
void | cs_post_write_meshes (const cs_time_step_t *ts)
| Output post-processing meshes using associated writers. More...
void | cs_post_write_var (int mesh_id, const char *var_name, int var_dim, bool interlace, bool use_parent, cs_post_type_t var_type, const void *cel_vals, const void *i_face_vals, const void *b_face_vals, const cs_time_step_t *ts)
| Output a variable defined at cells or faces of a post-processing mesh using associated writers. More...
void | cs_post_write_vertex_var (int mesh_id, const char *var_name, int var_dim, bool interlace, bool use_parent, cs_post_type_t var_type, const void *vtx_vals, const cs_time_step_t *ts)
| Output a variable defined at vertices of a post-processing mesh using associated writers. More...
void | cs_post_write_particle_values (int mesh_id, int attr_id, const char *var_name, int component_id, const cs_time_step_t *ts)
| Output an existing lagrangian particle attribute at particle positions or trajectory endpoints of a particle mesh using associated writers. More...
void | cs_post_renum_cells (const cs_lnum_t init_cell_num[])
| Update references to parent mesh of post-processing meshes in case of computational mesh cell renumbering. More...
void | cs_post_renum_faces (const cs_lnum_t init_i_face_num[], const cs_lnum_t init_b_face_num[])
| Update references to parent mesh of post-processing meshes in case of computational mesh interior and/or boundary faces renumbering. More...
void | cs_post_init_moments (const cs_real_t *cumulative_time)
| Initialize post-processing of moments. More...
void | cs_post_init_writers (void)
| Initialize post-processing writers. More...
void | cs_post_init_meshes (int check_mask)
| Initialize main post-processing meshes. More...
void | cs_post_write_vars (const cs_time_step_t *ts)
| Loop on post-processing meshes to output variables. More...
void | cs_post_finalize (void)
| Destroy all structures associated with post-processing. More...
void | cs_post_add_free_faces (void)
| Postprocess free (isolated) faces of the current global mesh. More...
void | cs_post_init_error_writer (void)
| Initialize post-processing writer with same format and associated options as default writer, but no time dependency, intended to troubleshoot errors. More...
int | cs_post_init_error_writer_cells (void)
| Initialize post-processing writer with same format and associated options as default writer, but no time dependency, and associate and output global volume mesh. More...
void | cs_post_add_time_dep_output (cs_post_time_dep_output_t *function, void *input)
| Register a processing of time-dependent variables to the call to cs_post_write_vars(). More...
void | cs_post_add_time_mesh_dep_output (cs_post_time_mesh_dep_output_t *function, void *input)
| Register a processing of time-dependent variables than can be output on different meshes to the call to cs_post_write_vars(). More...

## Macro Definition Documentation

CS_POST_BOUNDARY_NR

Value:
(1 << 1) /* postprocess boundary
without reconstruction */

postprocess boundary without reconstruction

CS_POST_ON_LOCATION

Value:
(1 << 0) /* postprocess variables
on their base location
(volume for variables) */

postprocess variables on their base location (volume for variables)

## Typedef Documentation

cs_post_elt_select_t

Function pointer to elements selection definition.

Each function of this sort may be used to select a given type of element, usually cells, interior faces, or boundary faces.

If non-empty and not containing all elements, a list of elements of the main mesh should be allocated (using BFT_MALLOC) and defined by this function when called. This list's lifecycle is then managed by the postprocessing subsystem.

Note: if the input pointer is non-NULL, it must point to valid data when the selection function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_meshes() with a fixed-mesh writer before the data pointed to goes out of scope;

Parameters

  [in,out] | input | pointer to optional (untyped) value or structure
  [out] | n_elts | number of selected elements
  [out] | elt_list | list of selected elements (0 to n-1 numbering)

cs_post_time_dep_output_t

Function pointer associated with a specific post-processing output.

Such functions are registered using the cs_post_add_time_dep_output, and all registered functions are automatically called by cs_post_write_vars.

Note: if the input pointer is non-NULL, it must point to valid data when the output function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_var() or similar before the data pointed to goes out of scope.

Parameters

  [in,out] | input | pointer to optional (untyped) value or structure
  [in] | nt_cur_abs | current time step number
  [in] | t_cur_abs | absolute time at the current time step

cs_post_time_mesh_dep_output_t

Function pointer associated with a specific post-processing output on multiple meshes.

Such functions are registered using the cs_post_add_time_mesh_dep_vars(), and all registered functions are automatically called by cs_post_write_vars().

Note: if the input pointer is non-NULL, it must point to valid data when the output function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_var() or similar before the data pointed to goes out of scope.

Parameters

  [in,out] | input | pointer to optional (untyped) value or structure
  [in] | mesh_id | id of the output mesh for the current call
  [in] | cat_id | category id of the output mesh for the current call
  [in] | ent_flag | indicate global presence of cells (ent_flag[0]), interior faces (ent_flag[1]), or boundary faces (ent_flag[2])
  [in] | n_cells | local number of cells of post_mesh
  [in] | n_i_faces | local number of interior faces of post_mesh
  [in] | n_b_faces | local number of boundary faces of post_mesh
  [in] | cell_list | list of cells (1 to n) of post-processing mesh
  [in] | i_face_list | list of interior faces (1 to n) of post-processing mesh
  [in] | b_face_list | list of boundary faces (1 to n) of post-processing mesh
  [in] | nt_cur_abs | current time step number
  [in] | t_cur_abs | current physical time
  [in] | nt_cur_abs | current time step number
  [in] | t_cur_abs | absolute time at the current time step

## Enumeration Type Documentation

enum cs_post_type_t

Postprocessing input variable type.

Enumerator
CS_POST_TYPE_cs_int_t | Fortran integer
CS_POST_TYPE_cs_real_t | Fortran double precision
CS_POST_TYPE_int | integer
CS_POST_TYPE_float | single precision floating-point value
CS_POST_TYPE_double | double precision floating-point value

## Function Documentation

void cs_post_activate_by_time_step | ( | const cs_time_step_t * | ts | ) |

Update "active" or "inactive" flag of writers based on the time step.

Writers are activated if their output frequency is a divisor of the current time step, or if their optional time step and value output lists contain matches for the current time step.

Parameters

  [in] | ts | time step status structure

void cs_post_activate_writer | ( | int | writer_id,
|  | bool | activate
| ) |  |

Force the "active" or "inactive" flag for a specific writer or for all writers for the current time step.

Parameters

  [in] | writer_id | writer id, or 0 for all writers
  [in] | activate | false to deactivate, true to activate

void cs_post_add_free_faces | ( | void |  | ) |

Postprocess free (isolated) faces of the current global mesh.

void cs_post_add_time_dep_output | ( | cs_post_time_dep_output_t * | function,
|  | void * | input
| ) |  |

Register a processing of time-dependent variables to the call to cs_post_write_vars().

Note: if the input pointer is non-NULL, it must point to valid data when the output function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_var() or similar before the data pointed to goes out of scope.

Parameters

  [in] | function | function to register
  [in,out] | input | pointer to optional (untyped) value or structure

void cs_post_add_time_mesh_dep_output | ( | cs_post_time_mesh_dep_output_t * | function,
|  | void * | input
| ) |  |

Register a processing of time-dependent variables than can be output on different meshes to the call to cs_post_write_vars().

Note: if the input pointer is non-NULL, it must point to valid data when the output function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_var() or similar before the data pointed to goes out of scope.

Parameters

  [in] | function | function to register
  [in,out] | input | pointer to optional (untyped) value or structure

void cs_post_add_writer_t_step | ( | int | writer_id,
|  | int | nt
| ) |  |

Add an activation time step for a specific writer or for all writers.

If a negative value is provided, a previously added activation time step matching that absolute value will be removed, if present.

Parameters

  [in] | writer_id | writer id, or 0 for all writers
  [in] | nt | time step value to add (or remove)

void cs_post_add_writer_t_value | ( | int | writer_id,
|  | double | t
| ) |  |

Add an activation time value for a specific writer or for all writers.

If a negative value is provided, a previously added activation time step matching that absolute value will be removed, if present.

Parameters

  [in] | writer_id | writer id, or 0 for all writers
  [in] | t | time value to add (or remove)

void cs_post_define_alias_mesh | ( | int | mesh_id,
|  | int | aliased_mesh_id,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Create an alias to a post-processing mesh.

An alias allows association of an extra identifier (id) to an existing post-processing mesh, and thus to associate different writers than those associated with the existing mesh. For example, this allows outputting a set of main variables every n1 time steps with one writer, and outputting a specific set of variables every n2 time time steps to another post-processing set using another writer, without the overhead that would be incurred by duplication of the post-processing mesh.

An alias is thus treated in all points like its associated mesh; if the definition of either one is modified, that of the other is modified also.

It is forbidden to associate an alias to another alias (as there is no identified use for this, and it would make consistency checking more difficult), but multiple aliases may be associated with a given mesh.

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | aliased_mesh_id | id of aliased mesh
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_edges_mesh | ( | int | mesh_id,
|  | int | base_mesh_id,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Create a mesh based upon the extraction of edges from an existing mesh.

The newly created edges have no link to their parent elements, so no variable referencing parent elements may be output to this mesh, whose main use is to visualize "true" face edges when polygonal faces are subdivided by the writer. In this way, even highly non-convex faces may be visualized correctly if their edges are overlaid on the surface mesh with subdivided polygons.

Parameters

  [in] | mesh_id | id of edges mesh to create (< 0 reserved, > 0 for user)
  [in] | base_mesh_id | id of existing mesh (< 0 reserved, > 0 for user)
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_existing_mesh | ( | int | mesh_id,
|  | fvm_nodal_t * | exp_mesh,
|  | int | dim_shift,
|  | bool | transfer,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Create a post-processing mesh associated with an existing exportable mesh representation.

If the exportable mesh is not intended to be used elsewhere, one can choose to transfer its property to the post-processing mesh, which will then manage its lifecycle based on its own requirements.

If the exportable mesh must still be shared, one must be careful to maintain consistency between this mesh and the post-processing output.

The mesh in exportable dimension may be of a lower dimension than its parent mesh, if it has been projected. In this case, a dim_shift value of 1 indicates that parent cells are mapped to exportable faces, and faces to edges, while a dim_shift value of 2 would indicate that parent cells are mapped to edges. This is important when variables values are exported.

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | exp_mesh | mesh in exportable representation (i.e. fvm_nodal_t)
  [in] | dim_shift | nonzero if exp_mesh has been projected
  [in] | transfer | if true, ownership of exp_mesh is transferred to the post-processing mesh
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_particles_mesh | ( | int | mesh_id,
|  | const char * | mesh_name,
|  | const char * | cell_criteria,
|  | double | density,
|  | bool | trajectory,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Define a particles post-processing mesh.

Such a mesh is always time-varying, and will only be output by writers defined with the FVM_WRITER_TRANSIENT_CONNECT option.

If the trajectory_mode argument is set to true, this logic is reversed, and output will only occur for writers defined with the FVM_WRITER_FIXED_MESH option. In this case, a submesh consisting of trajectory segments for the current time step will be added to the output at each output time step.

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | mesh_name | associated mesh name
  [in] | cell_criteria | selection criteria for cells containing particles, or NULL.
  [in] | density | fraction of the particles in the selected area which should be output (0 < density <= 1)
  [in] | trajectory | if true, activate trajectory mode
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_particles_mesh_by_func | ( | int | mesh_id,
|  | const char * | mesh_name,
|  | cs_post_elt_select_t * | p_select_func,
|  | void * | p_select_input,
|  | bool | trajectory,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Define a particles post-processing mesh using a selection function.

The selection may be updated over time steps.

Such a mesh is always time-varying, and will only be output by writers defined with the FVM_WRITER_TRANSIENT_CONNECT option.

If the trajectory_mode argument is set to true, this logic is reversed, and output will only occur for writers defined with the FVM_WRITER_FIXED_MESH option. In this case, a submesh consisting of trajectory segments for the current time step will be added to the output at each output time step.

Note: if the p_select_input pointer is non-NULL, it must point to valid data when the selection function is called, so that value or structure should not be temporary (i.e. local);

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | mesh_name | associated mesh name
  [in] | p_select_func | pointer to particles selection function
  [in] | p_select_input | pointer to optional input data for the particles selection function, or NULL
  [in] | trajectory | if true, activate trajectory mode
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_surface_mesh | ( | int | mesh_id,
|  | const char * | mesh_name,
|  | const char * | i_face_criteria,
|  | const char * | b_face_criteria,
|  | bool | add_groups,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Define a surface post-processing mesh.

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | mesh_name | associated mesh name
  [in] | i_face_criteria | selection criteria for interior faces
  [in] | b_face_criteria | selection criteria for boundary faces
  [in] | add_groups | if true, add group information if present
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_surface_mesh_by_func | ( | int | mesh_id,
|  | const char * | mesh_name,
|  | cs_post_elt_select_t * | i_face_select_func,
|  | cs_post_elt_select_t * | b_face_select_func,
|  | void * | i_face_select_input,
|  | void * | b_face_select_input,
|  | bool | time_varying,
|  | bool | add_groups,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Define a surface post-processing mesh using selection functions.

The selection may be updated over time steps if both the time_varying flag is set to true and the mesh is only associated with writers defined with the FVM_WRITER_TRANSIENT_CONNECT option.

Note: if i_face_select_input or b_face_select_input pointer is non-NULL, it must point to valid data when the selection function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_meshes() with a fixed-mesh writer before the data pointed to goes out of scope;

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | mesh_name | associated mesh name
  [in] | i_face_select_func | pointer to interior faces selection function
  [in] | b_face_select_func | pointer to boundary faces selection function
  [in] | i_face_select_input | pointer to optional input data for the interior faces selection function, or NULL
  [in] | b_face_select_input | pointer to optional input data for the boundary faces selection function, or NULL
  [in] | time_varying | if true, try to redefine mesh at each output time
  [in] | add_groups | if true, add group information if present
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_volume_mesh | ( | int | mesh_id,
|  | const char * | mesh_name,
|  | const char * | cell_criteria,
|  | bool | add_groups,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Define a volume post-processing mesh.

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | mesh_name | associated mesh name
  [in] | cell_criteria | selection criteria for cells
  [in] | add_groups | if true, add group information if present
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_volume_mesh_by_func | ( | int | mesh_id,
|  | const char * | mesh_name,
|  | cs_post_elt_select_t * | cell_select_func,
|  | void * | cell_select_input,
|  | bool | time_varying,
|  | bool | add_groups,
|  | bool | auto_variables,
|  | int | n_writers,
|  | const int | writer_ids[]
| ) |  |

Define a volume post-processing mesh using a selection function.

The selection may be updated over time steps if both the time_varying flag is set to true and the mesh is only associated with writers defined with the FVM_WRITER_TRANSIENT_CONNECT option.

Note: if the cell_select_input pointer is non-NULL, it must point to valid data when the selection function is called, so either:

- that value or structure should not be temporary (i.e. local);
- post-processing output must be ensured using cs_post_write_meshes() with a fixed-mesh writer before the data pointed to goes out of scope;

Parameters

  [in] | mesh_id | id of mesh to define (< 0 reserved, > 0 for user)
  [in] | mesh_name | associated mesh name
  [in] | cell_select_func | pointer to cells selection function
  [in] | cell_select_input | pointer to optional input data for the cell selection function, or NULL
  [in] | time_varying | if true, try to redefine mesh at each output time
  [in] | add_groups | if true, add group information if present
  [in] | auto_variables | if true, automatic output of main variables
  [in] | n_writers | number of associated writers
  [in] | writer_ids | ids of associated writers

void cs_post_define_writer | ( | int | writer_id,
|  | const char * | case_name,
|  | const char * | dir_name,
|  | const char * | fmt_name,
|  | const char * | fmt_opts,
|  | fvm_writer_time_dep_t | time_dep,
|  | bool | output_at_end,
|  | int | frequency_n,
|  | double | frequency_t
| ) |  |

Define a writer; this objects manages a case's name, directory, and format, as well as associated mesh's time dependency, and the default output frequency for associated variables.

(end ignore by Doxygen)

This function must be called before the time loop. If a writer with a given id is defined multiple times, the last definition supercedes the previous ones.

Parameters

  [in] | writer_id | number of writer to create (< 0 reserved, > 0 for user)
  [in] | case_name | associated case name
  [in] | dir_name | associated directory name
  [in] | fmt_name | associated format name
  [in] | fmt_opts | associated format options string
  [in] | time_dep | FVM_WRITER_FIXED_MESH if mesh definitions are fixed, FVM_WRITER_TRANSIENT_COORDS if coordinates change, FVM_WRITER_TRANSIENT_CONNECT if connectivity changes
  [in] | output_at_end | force output at calculation end if not 0
  [in] | frequency_n | default output frequency in time-steps, or < 0
  [in] | frequency_t | default output frequency in seconds, or < 0 (has priority over frequency_n)

void cs_post_finalize | ( | void |  | ) |

Destroy all structures associated with post-processing.

void cs_post_free_mesh | ( | int | mesh_id | ) |

Remove a post-processing mesh.

No further post-processing output will be allowed on this mesh, so the associated structures may be freed.

A post-processing mesh that has been associated with a time-varying writer or that is referenced by an alias may not be removed.

Parameters

  [in] | mesh_id | postprocessing mesh id

const char* cs_post_get_default_format | ( | void |  | ) |

Return the default writer format name.

Returns
  name of the default writer format

const char* cs_post_get_default_format_options | ( | void |  | ) |

Return the default writer format options.

Returns
  default writer format options string

int cs_post_get_free_mesh_id | ( | void |  | ) |

Return the next "reservable" (i.e. non-user) mesh id available.

Returns
  the smallest negative integer present, -1

int cs_post_get_free_writer_id | ( | void |  | ) |

Return the next "reservable" (i.e. non-user) writer id available.

Returns
  the smallest negative integer present, -1

fvm_writer_t* cs_post_get_writer | ( | int | writer_id | ) |

Return a pointer to the FVM writer associated to a writer_id.

Parameters

  [in] | writer_id | associated writer id

Returns
  a pointer to a fvm_writer_t structure

void cs_post_init_error_writer | ( | void |  | ) |

Initialize post-processing writer with same format and associated options as default writer, but no time dependency, intended to troubleshoot errors.

int cs_post_init_error_writer_cells | ( | void |  | ) |

Initialize post-processing writer with same format and associated options as default writer, but no time dependency, and associate and output global volume mesh.

This is intended to help troubleshoot errors using fields based on cells.

Returns
  id of error output mesh (< 0), or 0 if all writers are deactivated

void cs_post_init_meshes | ( | int | check_mask | ) |

Initialize main post-processing meshes.

The check_flag variable is a mask, used for additionnal post-processing:

- If (check_flag & 1), volume submeshes are output by groups if more than one group is present and the default writer uses the EnSight format.

- If (check_flag & 2), boundary submeshes are output by groups if more than one group is present and the default writer uses the EnSight format.

Note that all alias-type post-processing meshes and the meshes they relate to should have been defined before calling this function, so it is recommended that user-defined post-processing meshes be defined before calling this function, though specific "automatic" meshes (for example those related to couplings) may be defined between this call and a time loop.

Parameters

  [in] | check_mask | mask used for additional output

void cs_post_init_moments | ( | const cs_real_t * | cumulative_time | ) |

Initialize post-processing of moments.

Currently, an external cumulative time array is simply mapped to the post-processing API.

void cs_post_init_writers | ( | void |  | ) |

Initialize post-processing writers.

bool cs_post_mesh_exists | ( | int | mesh_id | ) |

Check for the existence of a post-processing mesh of the given id.

Parameters

  [in] | mesh_id | mesh id to check

Returns
  true if mesh with this id exists, false otherwise

void cs_post_mesh_get_b_face_ids | ( | int | mesh_id,
|  | cs_lnum_t | b_face_ids[]
| ) |  |

Get a postprocessing mesh's list of boundary faces.

The array of boundary face ids must be of at least size cs_post_mesh_get_n_b_faces(mesh_id).

Parameters

  [in] | mesh_id | postprocessing mesh id
  [out] | b_face_ids | array of associated boundary faces ids (0 to n-1 numbering, relative to main mesh)

void cs_post_mesh_get_cell_ids | ( | int | mesh_id,
|  | cs_lnum_t * | cell_ids
| ) |  |

Get a postprocessing mesh's list of cells.

The array of cell ids must be of at least size cs_post_mesh_get_n_cells(mesh_id).

Parameters

  [in] | mesh_id | postprocessing mesh id
  [out] | cell_ids | array of associated cell ids (0 to n-1 numbering, relative to main mesh)

const int* cs_post_mesh_get_ent_flag | ( | int | mesh_id | ) |

Get a postprocessing meshes entity presence flag.

This flag is an array of 3 integers, indicating the presence of elements of given types on at least one subdomain (i.e. rank): 0: presence of cells 1: presence of interior faces 2: presence of boundary faces

Parameters

  [in] | mesh_id | postprocessing mesh id

Returns
  pointer to entity presence flag

void cs_post_mesh_get_i_face_ids | ( | int | mesh_id,
|  | cs_lnum_t | i_face_ids[]
| ) |  |

Get a postprocessing mesh's list of boundary faces.

The array of boundary face ids must be of at least size cs_post_mesh_get_n_b_faces(mesh_id).

Parameters

  [in] | mesh_id | postprocessing mesh id
  [out] | i_face_ids | array of associated interior faces ids (0 to n-1 numbering, relative to main mesh)

cs_lnum_t cs_post_mesh_get_n_b_faces | ( | int | mesh_id | ) |

Get a postprocessing mesh's number of boundary faces.

Parameters

  [in] | mesh_id | postprocessing mesh id

Returns
  number of cells of postprocessing mesh.

cs_lnum_t cs_post_mesh_get_n_cells | ( | int | mesh_id | ) |

Get a postprocessing mesh's number of cells.

Parameters

  [in] | mesh_id | postprocessing mesh id

Returns
  number of cells of postprocessing mesh.

cs_lnum_t cs_post_mesh_get_n_i_faces | ( | int | mesh_id | ) |

Get a postprocessing mesh's number of interior faces.

Parameters

  [in] | mesh_id | postprocessing mesh id

Returns
  number of cells of postprocessing mesh.

void cs_post_modify_mesh | ( | int | mesh_id,
|  | cs_lnum_t | n_cells,
|  | cs_lnum_t | n_i_faces,
|  | cs_lnum_t | n_b_faces,
|  | cs_lnum_t | cell_list[],
|  | cs_lnum_t | i_face_list[],
|  | cs_lnum_t | b_face_list[]
| ) |  |

void cs_post_renum_cells | ( | const cs_lnum_t | init_cell_num[] | ) |

Update references to parent mesh of post-processing meshes in case of computational mesh cell renumbering.

This function may be called only once, after possible renumbering of cells, to update existing post-processing meshes. Post-processing meshes defined after renumbering will automatically be based upon the new numbering, so this function will not need to be called again.

Parameters

  [in] | init_cell_num | initial cell numbering (1 to n, new -> old)

void cs_post_renum_faces | ( | const cs_lnum_t | init_i_face_num[],
|  | const cs_lnum_t | init_b_face_num[]
| ) |  |

Update references to parent mesh of post-processing meshes in case of computational mesh interior and/or boundary faces renumbering.

This function may be called only once, after possible renumbering of faces, to update existing post-processing meshes. Post-processing meshes defined after renumbering will automatically be based upon the new numbering, so this function will not need to be called again.

Parameters

  [in] | init_i_face_num | initial interior numbering (1 to n, new -> old)
  [in] | init_b_face_num | initial boundary numbering (1 to n, new -> old)

void cs_post_set_changing_connectivity | ( | void |  | ) |

Configure the post-processing output so that mesh connectivity may be automatically updated.

This is done for meshes defined using selection criteria or functions. The behavior of Lagrangian meshes is unchanged.

To be effective, this function should be called before defining postprocessing meshes.

void cs_post_set_deformable | ( | void |  | ) |

Configure the post-processing output so that a mesh displacement field may be output automatically for meshes based on the global volume mesh/.

void cs_post_write_meshes | ( | const cs_time_step_t * | ts | ) |

Output post-processing meshes using associated writers.

If the time step structure argument passed is NULL, a time-independent output will be assumed.

Parameters

  [in] | ts | time step status structure, or NULL

void cs_post_write_particle_values | ( | int | mesh_id,
|  | int | attr_id,
|  | const char * | var_name,
|  | int | component_id,
|  | const cs_time_step_t * | ts
| ) |  |

Output an existing lagrangian particle attribute at particle positions or trajectory endpoints of a particle mesh using associated writers.

Parameters

  [in] | mesh_id | id of associated mesh
  [in] | attr_id | associated particle attribute id
  [in] | var_name | name of variable to output
  [in] | component_id | if -1 : extract the whole attribute if >0 : id of the component to extract
  [in] | ts | time step status structure, or NULL

void cs_post_write_var | ( | int | mesh_id,
|  | const char * | var_name,
|  | int | var_dim,
|  | bool | interlace,
|  | bool | use_parent,
|  | cs_post_type_t | var_type,
|  | const void * | cel_vals,
|  | const void * | i_face_vals,
|  | const void * | b_face_vals,
|  | const cs_time_step_t * | ts
| ) |  |

Output a variable defined at cells or faces of a post-processing mesh using associated writers.

Parameters

  [in] | mesh_id | id of associated mesh
  [in] | var_name | name of variable to output
  [in] | var_dim | 1 for scalar, 3 for vector, 6 for symmetric tensor, 9 for non-symmetric tensor
  [in] | interlace | if a vector, true for interlaced values, false otherwise
  [in] | use_parent | true if values are defined on "parent" mesh, false if values are defined on post-processing mesh
  [in] | var_type | variable's data type
  [in] | cel_vals | cell values
  [in] | i_face_vals | interior face values
  [in] | b_face_vals | boundary face values
  [in] | ts | time step status structure, or NULL

void cs_post_write_vars | ( | const cs_time_step_t * | ts | ) |

Loop on post-processing meshes to output variables.

This handles all default fields output, as well as all registered output functions.

Parameters

  [in] | ts | time step status structure, or NULL

void cs_post_write_vertex_var | ( | int | mesh_id,
|  | const char * | var_name,
|  | int | var_dim,
|  | bool | interlace,
|  | bool | use_parent,
|  | cs_post_type_t | var_type,
|  | const void * | vtx_vals,
|  | const cs_time_step_t * | ts
| ) |  |

Output a variable defined at vertices of a post-processing mesh using associated writers.

Parameters

  [in] | mesh_id | id of associated mesh
  [in] | var_name | name of variable to output
  [in] | var_dim | 1 for scalar, 3 for vector, 6 for symmetric tensor, 9 for non-symmetric tensor
  [in] | interlace | if a vector, true for interlaced values, false otherwise
  [in] | use_parent | true if values are defined on "parent" mesh, false if values are defined on post-processing mesh
  [in] | var_type | variable's data type
  [in] | vtx_vals | vertex values
  [in] | ts | time step status structure, or NULL

bool cs_post_writer_exists | ( | int | writer_id | ) |

Check for the existence of a writer of the given id.

Parameters

  [in] | writer_id | writer id to check

Returns
  true if writer with this id exists, false otherwise